diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java
index b0268709a..9a69e2cd6 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java
@@ -36,7 +36,7 @@ public class SaveFormat19133
     {
         File worldDir = new File(savesDir, worldDirName);
 
-        if (dimension == Dimension.overworld)
+        if (dimension == Dimension.OVERWORLD)
         {
             return worldDir;
         }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java b/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
index c5b57133a..3d9ccc21f 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
@@ -56,7 +56,7 @@ public class WorldTypeGroups {
         );
         GROUPS.add(
             new Group(WorldTypes.OVERWORLD_SKYBLOCK)
-                .with(Dimension.nether, WorldTypes.NETHER_SKYBLOCK)
+                .with(Dimension.NETHER, WorldTypes.NETHER_SKYBLOCK)
         );
         GROUPS.add(
             new Group(WorldTypes.EMPTY)
@@ -70,7 +70,7 @@ public class WorldTypeGroups {
         private final Map<Dimension, WorldType> worldTypes = new HashMap<>();
 
         public Group(WorldType overworldType) {
-            worldTypes.put(Dimension.overworld, overworldType);
+            worldTypes.put(Dimension.OVERWORLD, overworldType);
         }
 
         public Group with(Dimension dimension, WorldType worldType) {
diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 63c4c7318..fe0078274 100644
--- a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -871,6 +871,7 @@ class WorkbenchGenerator {
 
         fence.addInput('X', Items.STICK).addInput('#', Blocks.PAPER_WALL).create("paper_wall_fence", new ItemStack(Blocks.FENCE_PAPER_WALL, 4));
         fence.addInput('X', Items.INGOT_IRON).addInput('#', Items.CHAINLINK).create("chainlink_fence", new ItemStack(Blocks.FENCE_CHAINLINK, 8));
+        fence.addInput('X', Items.INGOT_STEEL).addInput('#', Items.INGOT_STEEL_CRUDE).create("steel_fence", new ItemStack(Blocks.FENCE_STEEL, 8));
     }
 
     private static void generateFenceGates() {
@@ -1150,6 +1151,17 @@ class WorkbenchGenerator {
             .addInput('P', Blocks.PISTON_BASE)
             .create("sticky_piston", Blocks.PISTON_BASE_STICKY.getDefaultStack());
 
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "#I#",
+                "#R#")
+            .addInput('X', Items.INGOT_STEEL)
+            .addInput('#', Blocks.BRICK_STONE_POLISHED)
+            .addInput('I', Blocks.PISTON_BASE)
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("steel_piston", Blocks.PISTON_BASE_STEEL.getDefaultStack());
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "X#X",
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index 359137987..53c601d8c 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -67,6 +67,7 @@ import java.util.ArrayList;
 import java.util.Collections;
 import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 import java.util.Random;
 
 import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
@@ -81,7 +82,7 @@ public class MinecraftServer
     public static HashMap<String, Integer> field_6037_b = new HashMap<>();
     public NetworkListenThread networkServer;
     public PropertyManager propertyManager;
-    public WorldServer[] dimensionWorlds;
+    public Map<Integer, WorldServer> dimensionWorlds;
     public PlayerList playerList;
     private boolean serverRunning;
     public boolean serverStopped;
@@ -90,7 +91,7 @@ public class MinecraftServer
     public int percentDone;
     private final List<IUpdatePlayerListBox> playerListBoxes;
     private final List<ServerCommandEntry> commands;
-    public EntityTracker[] entityTracker;
+    public Map<Integer, EntityTracker> entityTrackerMap;
     public boolean onlineMode;
     public boolean pvpOn;
     public boolean allowFlight;
@@ -234,7 +235,7 @@ public class MinecraftServer
             }
         }
 
-        entityTracker = new EntityTracker[Dimension.getDimensionList().size()];
+        entityTrackerMap = new HashMap<>();
 
         new Registries();
         BiomeProviderOverworld.init();
@@ -302,9 +303,9 @@ public class MinecraftServer
             LOGGER.warn("To change this, set \"online-mode\" to \"true\" in the server.properties file.");
         }
         playerList = new PlayerList(this);
-        for (int q = 0; q < Dimension.getDimensionList().size(); q++)
+        for (Integer id : Dimension.getDimensionList().keySet())
         {
-            entityTracker[q] = new EntityTracker(this, q);
+            entityTrackerMap.put(id, new EntityTracker(this, id));
         }
         long time = System.nanoTime();
         String lName = propertyManager.getStringProperty("level-name", "world");
@@ -399,40 +400,43 @@ public class MinecraftServer
     private void initWorld(ISaveFormat saveFormat, String worldDirName, long l)
     {
         convertWorld(saveFormat, worldDirName);
-        dimensionWorlds = new WorldServer[Dimension.getDimensionList().size()];
+        dimensionWorlds = new HashMap<>();
         SaveHandlerServer saveHandler = new SaveHandlerServer(saveFormat, new File("."), worldDirName, true);
-        for (int i = 0; i < dimensionWorlds.length; i++)
+        for (Map.Entry<Integer, Dimension> entry : Dimension.getDimensionList().entrySet())
         {
-            if (i == 0)
+            int dimId = entry.getKey();
+            Dimension dimension = entry.getValue();
+            WorldServer worldServer;
+            if (dimId == 0)
             {
-                dimensionWorlds[i] = new WorldServer(this, saveHandler, worldDirName, i, defaultWorldType, l, spawnerConfig);
+                worldServer = new WorldServer(this, saveHandler, worldDirName, dimId, defaultWorldType, l, spawnerConfig);
             }
             else
             {
-                dimensionWorlds[i] = new WorldServerMulti(this, saveHandler, worldDirName, i, Dimension.getDimensionList().get(i).defaultWorldType, l, dimensionWorlds[0], spawnerConfig);
+                worldServer = new WorldServerMulti(this, saveHandler, worldDirName, dimId, dimension.defaultWorldType, l, dimensionWorlds.get(0), spawnerConfig);
             }
-            dimensionWorlds[i].addListener(new WorldManager(this, dimensionWorlds[i]));
-            dimensionWorlds[i].setDifficulty(difficulty, true);
-            dimensionWorlds[i].sleepPercent = sleepPercentage;
+            dimensionWorlds.put(dimId, worldServer);
+            worldServer.addListener(new WorldManager(this, dimensionWorlds.get(dimId)));
+            worldServer.setDifficulty(difficulty, true);
+            worldServer.sleepPercent = sleepPercentage;
             playerList.setPlayerManager(dimensionWorlds);
         }
 
         char c = '\304';
         long l1 = System.currentTimeMillis();
         label0:
-        for (int j = 0; j < dimensionWorlds.length; j++)
+        for (WorldServer worldServer : dimensionWorlds.values())
         {
-            LOGGER.info("Preparing start region for level " + j);
-            if (j == Dimension.nether.id && !propertyManager.getBooleanProperty("allow-nether", true))
+            LOGGER.info("Preparing start region for level {}", worldServer.dimension);
+            if (worldServer.dimension == Dimension.NETHER && !propertyManager.getBooleanProperty("allow-nether", true))
             {
                 continue;
             }
-            if (j == Dimension.paradise.id && !propertyManager.getBooleanProperty("allow-paradise", false))
+            if (worldServer.dimension == Dimension.PARADISE && !propertyManager.getBooleanProperty("allow-paradise", false))
             {
                 continue;
             }
-            WorldServer worldserver = dimensionWorlds[j];
-            ChunkCoordinates chunkcoordinates = worldserver.getSpawnPoint();
+            ChunkCoordinates chunkcoordinates = worldServer.getSpawnPoint();
             int k = -c;
             do
             {
@@ -454,8 +458,8 @@ public class MinecraftServer
                         outputPercentRemaining("Preparing spawn area", (k1 * 100) / j1);
                         l1 = l2;
                     }
-                    worldserver.chunkProviderServer.prepareChunk(chunkcoordinates.x + k >> 4, chunkcoordinates.z + i1 >> 4);
-                    while (worldserver.updatingLighting() && serverRunning) ;
+                    worldServer.chunkProviderServer.prepareChunk(chunkcoordinates.x + k >> 4, chunkcoordinates.z + i1 >> 4);
+                    while (worldServer.updatingLighting() && serverRunning) ;
                 }
 
                 k += 16;
@@ -482,11 +486,10 @@ public class MinecraftServer
     private void saveServerWorld()
     {
         LOGGER.info("Saving chunks");
-        for (int i = 0; i < dimensionWorlds.length; i++)
+        for (WorldServer worldServer : dimensionWorlds.values())
         {
-            WorldServer worldserver = dimensionWorlds[i];
-            worldserver.saveWorld(true, null, i == 0);
-            worldserver.func_30006_w();
+            worldServer.saveWorld(true, null, worldServer.dimension == Dimension.OVERWORLD);
+            worldServer.checkLock();
         }
 
     }
@@ -539,7 +542,7 @@ public class MinecraftServer
                     }
                     timeSinceLastTick += timeChange;
                     startTime = currentTime;
-                    if (dimensionWorlds[0].areEnoughPlayersFullyAsleep())
+                    if (dimensionWorlds.get(Dimension.OVERWORLD.id).areEnoughPlayersFullyAsleep())
                     {
                         doTick();
                         timeSinceLastTick = 0L;
@@ -632,31 +635,30 @@ public class MinecraftServer
         AABB.initializePool();
         Vec3.initializePool();
         deathTime++;
-        for (int i = 0; i < dimensionWorlds.length; i++)
+        for (WorldServer worldServer : dimensionWorlds.values())
         {
-            if (i == Dimension.nether.id && !propertyManager.getBooleanProperty("allow-nether", true))
+            if (worldServer.dimension == Dimension.NETHER && !propertyManager.getBooleanProperty("allow-nether", true))
             {
                 continue;
             }
-            if (i == Dimension.paradise.id && !propertyManager.getBooleanProperty("allow-paradise", false))
+            if (worldServer.dimension == Dimension.PARADISE && !propertyManager.getBooleanProperty("allow-paradise", false))
             {
                 continue;
             }
-            WorldServer worldserver = dimensionWorlds[i];
             if (deathTime % 20 == 0)
             {
-                playerList.sendPacketToAllPlayersInDimension(new SetTimePacket(worldserver.getWorldTime()), worldserver.dimension.id);
+                playerList.sendPacketToAllPlayersInDimension(new SetTimePacket(worldServer.getWorldTime()), worldServer.dimension.id);
             }
-            worldserver.tick();
-            while (worldserver.updatingLighting()) ;
-            worldserver.updateEntities();
+            worldServer.tick();
+            while (worldServer.updatingLighting()) ;
+            worldServer.updateEntities();
         }
 
         networkServer.handleNetworkListenThread();
         playerList.onTick();
-        for (int k = 0; k < entityTracker.length; k++)
+        for (EntityTracker tracker : entityTrackerMap.values())
         {
-            entityTracker[k].tick();
+            tracker.tick();
         }
 
         for (int l = 0; l < playerListBoxes.size(); l++)
@@ -750,14 +752,14 @@ public class MinecraftServer
         return "CONSOLE";
     }
 
-    public WorldServer getDimensionWorld(int dim)
+    public WorldServer getDimensionWorld(int dimId)
     {
-        return dimensionWorlds[dim];
+        return dimensionWorlds.get(dimId);
     }
 
-    public EntityTracker getEntityTracker(int i)
+    public EntityTracker getEntityTracker(int dimId)
     {
-        return entityTracker[i];
+        return entityTrackerMap.get(dimId);
     }
 
     public static boolean isServerRunning(MinecraftServer minecraftserver)
diff --git a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
index 095e6dcf5..c05fb0ac7 100644
--- a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
+++ b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
@@ -304,7 +304,7 @@ public class ServerPlayer extends Player implements ContainerListener {
             int targetDim = ((PortalBlock) Block.blocksList[portalID]).targetDimension;
             boolean netherAllowed = mcServer.propertyManager.getBooleanProperty("allow-nether", true);
             boolean paradiseAllowed = mcServer.propertyManager.getBooleanProperty("allow-paradise", false);
-            if ((netherAllowed && targetDim == Dimension.nether.id) || (paradiseAllowed && targetDim == Dimension.paradise.id) || (targetDim != Dimension.nether.id && targetDim != Dimension.paradise.id))
+            if ((netherAllowed && targetDim == Dimension.NETHER.id) || (paradiseAllowed && targetDim == Dimension.PARADISE.id) || (targetDim != Dimension.NETHER.id && targetDim != Dimension.PARADISE.id))
             {
                 if (craftingInventory != inventorySlots)
                 {
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index 9db306f4b..237c9fd96 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -32,7 +32,7 @@ public class PlayerList
     public static Logger logger = LogUtils.getLogger();
     public List<ServerPlayer> playerEntities;
     private final MinecraftServer server;
-    private final PlayerManager[] playerManagers;
+    private final Map<Integer, PlayerManager> playerManagers;
     private final Set<UUID> bans;
     private final Set<String> ipBans;
     private final Set<UUID> ops;
@@ -53,16 +53,16 @@ public class PlayerList
         ipBans = new HashSet<>();
         ops = new HashSet<>();
         whitelist = new HashSet<>();
-        playerManagers = new PlayerManager[Dimension.getDimensionList().size()];
+        playerManagers = new HashMap<>();
         this.server = server;
         bansFile = server.getFile("banned-players.txt");
         ipBansFile = server.getFile("banned-ips.txt");
         opsFile = server.getFile("ops.txt");
         whitelistFile = server.getFile("white-list.txt");
         int viewDistance = server.propertyManager.getIntProperty("view-distance", 10);
-        for (int dim = 0; dim < Dimension.getDimensionList().size(); dim++)
+        for (Integer dim : Dimension.getDimensionList().keySet())
         {
-            playerManagers[dim] = new PlayerManager(server, dim, viewDistance);
+            playerManagers.put(dim, new PlayerManager(server, dim, viewDistance));
         }
         whitelistEnforced = server.propertyManager.getBooleanProperty("white-list", false);
         loadBannedPlayers();
@@ -102,14 +102,14 @@ public class PlayerList
         }
     }
 
-    public void setPlayerManager(WorldServer[] aworldserver)
+    public void setPlayerManager(Map<Integer, WorldServer> worldServerMap)
     {
-        playerIo = aworldserver[0].getSaveHandler().getPlayerFileData();
+        playerIo = worldServerMap.get(0).getSaveHandler().getPlayerFileData();
     }
 
     public void syncPlayerDimension(ServerPlayer player)
     {
-        for (PlayerManager playerManager : playerManagers) {
+        for (PlayerManager playerManager : playerManagers.values()) {
             playerManager.removePlayer(player);
         }
         getPlayerManager(player.dimension).addPlayer(player);
@@ -119,12 +119,12 @@ public class PlayerList
 
     public int getMaxTrackingDistance()
     {
-        return playerManagers[0].getMaxTrackingDistance();
+        return playerManagers.get(0).getMaxTrackingDistance();
     }
 
     public PlayerManager getPlayerManager(int dim)
     {
-        return playerManagers[dim];
+        return playerManagers.get(dim);
     }
 
     public void load(ServerPlayer player)
@@ -302,7 +302,7 @@ public class PlayerList
 
     public void onTick()
     {
-        for (PlayerManager playerManager : playerManagers) {
+        for (PlayerManager playerManager : playerManagers.values()) {
             playerManager.tick();
         }
     }
diff --git a/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java b/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java
index 14de55a97..f6ef35440 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java
@@ -68,7 +68,7 @@ public class DifficultyCommand {
 
         MinecraftServer server = ((IServerCommandSource)source).getServer();
 
-        for (World world : server.dimensionWorlds) {
+        for (World world : server.dimensionWorlds.values()) {
             world.setDifficulty(difficulty, true);
         }
         server.difficulty = difficulty;
diff --git a/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java b/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java
index fbfc0e334..60511eeca 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java
@@ -3,6 +3,7 @@ package net.minecraft.server.net.command.commands;
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.net.command.IServerCommandSource;
@@ -22,8 +23,8 @@ public class StopCommand {
                     if (server.playerList != null) {
                         server.playerList.savePlayerStates();
                     }
-                    for (int i = 0; i < server.dimensionWorlds.length; ++i) {
-                        server.dimensionWorlds[i].saveWorld(true, null, true);
+                    for (World world : server.dimensionWorlds.values()) {
+                        world.saveWorld(true, null, true);
                     }
                     server.initiateShutdown();
                     return Command.SINGLE_SUCCESS;
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index f361f09e7..4a9ae8e22 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -231,7 +231,7 @@ public class WorldServer extends World
         mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new BlockEventPacket(x, y, z, index, data));
     }
 
-    public void func_30006_w()
+    public void checkLock()
     {
         saveHandler.checkSessionLock();
     }
